package  
{
	import flash.display.Sprite;
	
	
	public class TheWorld extends Sprite
	{
		//const
		public const ballRR:Number = 10;
		public const boxWidth:Number = 800;
		public const boxHeight:Number = 600;
		public const nnBall:int = 100;
		
		public var ballArray:Array;
		
		
		//physics
		public const v0:Number = 15;
		public var tt:Number = 0;
		public var dt:Number = 0.2;
		
		public function TheWorld():void
		{
			//once
			
			//bg
			this.addChild(new bgMC());
			
			
			//ball
			ballArray = new Array();
			for (var i:int=0; i < nnBall; i++) {
				var ball:OneBall = new OneBall();
				
				//位置
				ball.x=ball.xx = (Math.random() - 0.5) * boxWidth;//-400~+400
				ball.y=ball.yy = (Math.random() - 0.5) * boxHeight;//-300~+300
				//vv
				var theta:Number = Math.random() * 2 * Math.PI;//0~ 2 pi
				ball.vx = v0 * Math.cos(theta);
				ball.vy = v0 * Math.sin(theta);
				
				this.addChild(ball);
				ballArray.push(ball);
				
			}
			
			
		}
		
		
		public function myUpdate():void {
			
			
			//wall
			for (var i:int = 0; i < nnBall; i++) {
				
				var ball:OneBall = ballArray[i];
				
				ball.xx += ball.vx * dt;
				ball.yy += ball.vy * dt;
				
				
				//wall
				if (ball.xx > (0.5 * boxWidth - ballRR) && ball.vx>0) {//右
					ball.vx = -1 * ball.vx;
					ball.mc.gotoAndPlay(2);
				}else if (ball.xx < (-0.5 * boxWidth + ballRR) && ball.vx<0) {//左
					ball.vx = -1 * ball.vx;
					ball.mc.gotoAndPlay(2);
				}
				
				if (ball.yy> (0.5 * boxHeight - ballRR) && ball.vy>0) {//下
					ball.vy = -1 * ball.vy;
					ball.mc.gotoAndPlay(2);
				}else if (ball.yy < (-0.5 * boxHeight + ballRR) && ball.vy<0) {//上
					ball.vy = -1 * ball.vy;
					ball.mc.gotoAndPlay(2);
				}
				
				
				
			}
			
			
			//相撞
			for (var i:int = 0; i <= (nnBall - 2); i++) {
				var ball1:OneBall = ballArray[i];//1
				
				for (var j:int = 1; j <= (nnBall - 1); j++ ) {
					var ball2:OneBall = ballArray[j];//2
					
					
					
					//check
					var r12x:Number = ball1.xx - ball2.xx;
					var r12y:Number = ball1.yy - ball2.yy;
					var rr:Number = Math.sqrt(r12x * r12x + r12y * r12y);
					var vcx:Number = 0.5 * (ball1.vx + ball2.vx);
					var vcy:Number = 0.5 * (ball1.vy + ball2.vy);
					
					var v1cx:Number = ball1.vx - vcx;//v1c
					var v1cy:Number = ball1.vy - vcy;
					
					var v2cx:Number = ball2.vx - vcx;//v2c
					var v2cy:Number = ball2.vy - vcy;
					
					
					if (rr < 2 * ballRR && (v1cx * r12x + v1cy * r12y) < 0) {
						
						//ring
						ball1.mc.gotoAndPlay(2);
						ball2.mc.gotoAndPlay(2);
						
						//r12單位向量
						var n12x:Number = r12x / rr;
						var n12y:Number = r12y / rr;
						
						//處理ball 1
						var v1c_n12:Number = Math.abs(v1cx * n12x + v1cy * n12y);//v1c內積n12
						var vvpx:Number = v1c_n12 * n12x;
						var vvpy:Number = v1c_n12 * n12y;
						
						var u1cx:Number = v1cx + 2 * vvpx;
						var u1cy:Number = v1cy + 2 * vvpy;
						
						ball1.vx = u1cx + vcx;
						ball1.vy = u1cy + vcy;
						
						
						//處理ball 2
						var v2c_n12:Number = Math.abs(v2cx * n12x + v2cy * n12y);//v2c內積n12
						var vvp2x:Number = -v2c_n12 * n12x;
						var vvp2y:Number = -v2c_n12 * n12y;
						
						var u2cx:Number = v2cx + 2 * vvp2x;
						var u2cy:Number = v2cy + 2 * vvp2y;
						
						ball2.vx = u2cx + vcx;
						ball2.vy = u2cy + vcy;
						
						
					}
					
					
					
					
				}
				
				
			}
			
			
			
			//show
			for (var i:int = 0; i < nnBall; i++) {
				
				var ball:OneBall = ballArray[i];
				
				ball.x = ball.xx;
				ball.y = ball.yy;
				
			}
			
		}
		
	}

}